// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.12.4
// source: question/question_svc.proto

package question

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// QuestionServiceClient is the client API for QuestionService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type QuestionServiceClient interface {
	SetQuestion(ctx context.Context, opts ...grpc.CallOption) (QuestionService_SetQuestionClient, error)
	GetQuestion(ctx context.Context, in *GetQuestionRequest, opts ...grpc.CallOption) (*Question, error)
}

type questionServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewQuestionServiceClient(cc grpc.ClientConnInterface) QuestionServiceClient {
	return &questionServiceClient{cc}
}

func (c *questionServiceClient) SetQuestion(ctx context.Context, opts ...grpc.CallOption) (QuestionService_SetQuestionClient, error) {
	stream, err := c.cc.NewStream(ctx, &QuestionService_ServiceDesc.Streams[0], "/question.QuestionService/SetQuestion", opts...)
	if err != nil {
		return nil, err
	}
	x := &questionServiceSetQuestionClient{stream}
	return x, nil
}

type QuestionService_SetQuestionClient interface {
	Send(*Question) error
	CloseAndRecv() (*SetQuestionResponse, error)
	grpc.ClientStream
}

type questionServiceSetQuestionClient struct {
	grpc.ClientStream
}

func (x *questionServiceSetQuestionClient) Send(m *Question) error {
	return x.ClientStream.SendMsg(m)
}

func (x *questionServiceSetQuestionClient) CloseAndRecv() (*SetQuestionResponse, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(SetQuestionResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *questionServiceClient) GetQuestion(ctx context.Context, in *GetQuestionRequest, opts ...grpc.CallOption) (*Question, error) {
	out := new(Question)
	err := c.cc.Invoke(ctx, "/question.QuestionService/GetQuestion", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// QuestionServiceServer is the server API for QuestionService service.
// All implementations must embed UnimplementedQuestionServiceServer
// for forward compatibility
type QuestionServiceServer interface {
	SetQuestion(QuestionService_SetQuestionServer) error
	GetQuestion(context.Context, *GetQuestionRequest) (*Question, error)
	mustEmbedUnimplementedQuestionServiceServer()
}

// UnimplementedQuestionServiceServer must be embedded to have forward compatible implementations.
type UnimplementedQuestionServiceServer struct {
}

func (UnimplementedQuestionServiceServer) SetQuestion(QuestionService_SetQuestionServer) error {
	return status.Errorf(codes.Unimplemented, "method SetQuestion not implemented")
}
func (UnimplementedQuestionServiceServer) GetQuestion(context.Context, *GetQuestionRequest) (*Question, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetQuestion not implemented")
}
func (UnimplementedQuestionServiceServer) mustEmbedUnimplementedQuestionServiceServer() {}

// UnsafeQuestionServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to QuestionServiceServer will
// result in compilation errors.
type UnsafeQuestionServiceServer interface {
	mustEmbedUnimplementedQuestionServiceServer()
}

func RegisterQuestionServiceServer(s grpc.ServiceRegistrar, srv QuestionServiceServer) {
	s.RegisterService(&QuestionService_ServiceDesc, srv)
}

func _QuestionService_SetQuestion_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(QuestionServiceServer).SetQuestion(&questionServiceSetQuestionServer{stream})
}

type QuestionService_SetQuestionServer interface {
	SendAndClose(*SetQuestionResponse) error
	Recv() (*Question, error)
	grpc.ServerStream
}

type questionServiceSetQuestionServer struct {
	grpc.ServerStream
}

func (x *questionServiceSetQuestionServer) SendAndClose(m *SetQuestionResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *questionServiceSetQuestionServer) Recv() (*Question, error) {
	m := new(Question)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _QuestionService_GetQuestion_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetQuestionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QuestionServiceServer).GetQuestion(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/question.QuestionService/GetQuestion",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QuestionServiceServer).GetQuestion(ctx, req.(*GetQuestionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// QuestionService_ServiceDesc is the grpc.ServiceDesc for QuestionService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var QuestionService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "question.QuestionService",
	HandlerType: (*QuestionServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetQuestion",
			Handler:    _QuestionService_GetQuestion_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "SetQuestion",
			Handler:       _QuestionService_SetQuestion_Handler,
			ClientStreams: true,
		},
	},
	Metadata: "question/question_svc.proto",
}
